--  Copyright 2014-2016 Emutex Ltd. All rights reserved.

PRAGMA foreign_keys=OFF;
BEGIN TRANSACTION;
CREATE TABLE device(
    vendor_ID INT,
    device_ID TEXT,
    name TEXT,
    MAC TEXT,
    active INT default 1,
    keepalive INT default 300,
    mobile INT default 0,
    latitude REAL,
    longitude REAL,
    last_connection INT default 0,
    config_timestamp  INT default 0,
    PRIMARY KEY (vendor_ID, device_ID) );
CREATE TABLE device_config(
    vendor_ID INT,
    device_ID TEXT,
    name TEXT,
    value TEXT,
    PRIMARY KEY(vendor_ID, device_ID, name),
    FOREIGN KEY (vendor_ID) REFERENCES device(vendor_ID));
CREATE TABLE samples(
    sample_id INTEGER PRIMARY KEY AUTOINCREMENT,
    sensor_ID TEXT,
    device_ID TEXT,
    vendor_ID INT,
    value TEXT,
    seconds INT,
    useconds INT,
    latitude REAL,
    longitude REAL,
    sequence INT);
CREATE INDEX sequence_index ON samples(sequence);
CREATE INDEX sensor_sequence_index ON samples(vendor_ID, device_ID, sensor_ID, sequence);
CREATE TABLE node(
    vendor_ID INT,
    device_ID TEXT,
    node_ID TEXT,
    name TEXT,
    type INT,
    hwtype TEXT,
    hwaddr TEXT,
    mobile INT,
    latitude REAL,
    longitude REAL,
    active INT,
    timestamp INT default 0,
    origin INT default 0,
    sampleRate INT default 60000);
CREATE TABLE sensor(
    vendor_ID INT,
    device_ID TEXT,
    sensor_ID TEXT,
    name TEXT,
    type INT,
    hwtype TEXT,
    hwaddr TEXT,
    scale FLOAT,
    offset FLOAT,
    max FLOAT,
    min FLOAT,
    units TEXT,
    mobile INT,
    latitude REAL,
    longitude REAL,
    active INT,
    timestamp  INT default 0,
    origin  INT default 0,
    sampleRate INT default 60000,
    node_ID TEXT default NULL);
DELETE FROM sqlite_sequence;
INSERT INTO "sqlite_sequence" VALUES('samples',0);
COMMIT;
