-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--! \file
--! \brief Module to connect to server  where data are put
libOpen ("mqtt.so.1.0")
libOpen("modem.so.1.0");
libOpen ("digi.so.1.0")
libOpen ("iio.so.1.0")
libOpen ("gpio.so.1.0")
libOpen ("capture.so.1.0")


-- Incident Thresholds --
local incident_timer = 15000
local report_timer = 5000

local kph_threshold = 70
local rpm_threshold = 3200
local accel_threshold = 300

local kph_event = ""
local mpg_event = ""
local rpm_event = ""
local longitude_event = ""
local latitude_event = ""
local event_text = ""
local time_event = ""
local accel_event_triggered = false

local sms_enabled = 1

--Event type
events= {}
events["mycar_ii_kph_event"] = 1
events["mycar_ii_rpm_event"] = 2
events["accelerometer_event"] = 3

function pollGPS(event)
  timerStart ("gps.timer", 10000);
end


function send_file(event)

  name = tagGetString("name_file");
  copy = require "apps/mycar2/sendFiles"
  print("\nSending incident video: " .. name .. "\n");
  copy.sendFile(name)

  timeS = tagGetNum("gps_time");
  timeS = tonumber(timeS);
  latitude = tagGetNum("latitude");
  longitude = tagGetNum("longitude");

  if latitude == "" then
    latitude=0;
  end

  if longitude == "" then
    longitude=0
  end

  if timeS > 0 then

    local name = tagGetString("name_file");
    name_change = string.gsub(name, ".h264", ".mp4");
    print("Sending incident to MQTT\n");
    if latitude ~= 0 and longitude ~= 0 then
      mqttPublish(mqtt_client, "com.mycar2.mycar_data", "value=kph=" ..
        kph_event .. "/rpm=" .. rpm_event .. "/mpg=" ..
        mpg_event .. "/event=" .. event_text .. "/time=" ..
        name_change .. ",time-sec=" .. time_event ..
        ",time-usec=0,latitude=" .. latitude_event ..
        ",longitude=" .. longitude_event, 0, false);

      tagSetString("mycar_data", "kph=" .. kph_event .. "/rpm=" ..
        rpm_event .. "/mpg=" .. mpg_event .. "/event=" ..
        event_text .. "/time=" .. name_change ..
        "/longitude=" .. longitude_event .. "/latitude=" ..
        latitude_event)
    end
  end

  tagSetNum("flag_video", 0);
end


function data_update_1m(event)

  --    gpsCordenate();
  --    print ("DOing getfix")
  --    gpsGetFix("gps_time","latitude","longitude","altitude","speed");
  --    print ("DOne getfix")
  timeS = tagGetNum("gps_time");
  latitude = tagGetNum("latitude");
  longitude = tagGetNum("longitude");
  latitude = tonumber(latitude);
  longitude = tonumber(longitude);
  timeS = tonumber(timeS);

  local kph = tonumber(tagGetNum ("mycar_ii_kph"));
  local mpg = tagGetNum ("mycar_ii_mpg");
  local rpm = tagGetNum ("mycar_ii_rpm");
  local accel_x = tagGetNum("accel_x");
  local accel_y = tagGetNum("accel_y");
  local accel_z = tagGetNum("accel_z");

  -- Variable reporting time. From 15s to 30s depending on the speed.
  if kph < 5 then
    timeUpdate = 30000;
  else
    timeUpdate = (900 / kph) * 1000;
  end

  if timeUpdate < 15000 then
    timeUpdate = 15000
  end

  print("Next report: " .. timeUpdate .. "ms")
  timerStart ("update1m.timer",timeUpdate);

  if (timeS>0) then
    mqttPublish(mqtt_client,"com.mycar2.speed","value="..kph..",time-sec="..timeS..",time-usec=0,latitude="..latitude..",longitude="..longitude,0,false);
    mqttPublish(mqtt_client,"com.mycar2.consumm","value="..mpg..",time-sec="..timeS..",time-usec=0,latitude="..latitude..",longitude="..longitude,0,false);
    mqttPublish(mqtt_client,"com.mycar2.revolution","value="..rpm..",time-sec="..timeS..",time-usec=0,latitude="..latitude..",longitude="..longitude,0,false);
    mqttPublish(mqtt_client,"com.mycar2.acceleration_x","value="..accel_x..",time-sec="..timeS..",time-usec=0,latitude="..latitude..",longitude="..longitude,0,false);
    mqttPublish(mqtt_client,"com.mycar2.acceleration_y","value="..accel_y..",time-sec="..timeS..",time-usec=0,latitude="..latitude..",longitude="..longitude,0,false);
    mqttPublish(mqtt_client,"com.mycar2.acceleration_z","value="..accel_z..",time-sec="..timeS..",time-usec=0,latitude="..latitude..",longitude="..longitude,0,false);

    if latitude ~= 0 and longitude ~= 0 then
      mqttPublish(mqtt_client, "com.mycar2.mycar_data",
        "value=kph=" .. kph .. "/rpm="..rpm.."/mpg="..mpg.."/event=0,time-sec="..timeS..",time-usec=0,latitude="..latitude..",longitude="..longitude,0,false);
    end
  end
  --    digiDefineFloat ("event_data", "kph/rpm/mpg/event/time/longitud/latitude", "datas", 3, 3);
  tagSetString("mycar_data", "kph="..kph.."/rpm="..rpm.."/mpg="..mpg.."/event=0/time="..timeS.."/longitude="..longitude.."/latitude="..latitude)

end

function rtdbEvent2HumanReadable (event_number)

  event_texts = {"over_speed", "over_rpm", "accelerometer_event"}

  if event_number < 1 or event_number > table.getn(event_texts) then
    return "Unknown event"
  end

  return event_texts[event_number]

end

function sendSMS(event_number)

  if sms_enabled == 1 then

    sms_text = "MyCar event - "
    sms_text = sms_text .. rtdbEvent2HumanReadable(event_number) .. " "
    sms_text = sms_text .. "(" .. latitude_event .. ", " ..
      longitude_event .. ") "
    sms_text = sms_text .. os.date("%x %X", time_event)

    if event_number == 1 then
      sms_text = sms_text .. " - " .. kph_event .. " kph"
    elseif event_number == 2 then
      sms_text = sms_text .. " - " .. rpm_event .. " rpm"
    end

    gsmModemSendSMS(mobile_number, sms_text)
    timerStart ("sms_fallback_timer", 300000);
    sms_enabled = 0
  end

end

function incident(event)

  enable_incident = tagGetNum("enable_incident")

  if enable_incident == 1 then
    event_number = events[event];
    event_text = rtdbEvent2HumanReadable(event_number)

    timeS = tagGetNum("gps_time");
    latitude = tagGetNum("latitude");
    longitude = tagGetNum("longitude");

    if latitude == "" then
      latitude = 0;
    end

    if longitude == "" then
      longitude = 0
    end

    latitude = tonumber(latitude);
    longitude = tonumber(longitude);
    timeS = tonumber(timeS);

    local accel_x = tagGetNum("accel_x");
    local accel_y = tagGetNum("accel_y");
    local accel_z = tagGetNum("accel_z");
    local kph = tagGetNum ("mycar_ii_kph_2s");
    local mpg = tagGetNum ("mycar_ii_mpg");
    local rpm = tagGetNum ("mycar_ii_rpm_2s");
    local name= tagGetString("name_file");
    name_change = string.gsub(name,".h264",".mp4");

    if timeS > 0 then

      print("\n*** Incident ***\n");
      mqttPublish(mqtt_client, "com.mycar2.speed", "value=" .. kph ..
        ",time-sec=" .. timeS .. ",time-usec=0,latitude=" ..
        latitude .. ",longitude=" .. longitude, 0, false);
      mqttPublish(mqtt_client, "com.mycar2.consumm", "value=" .. mpg ..
        ",time-sec=" .. timeS .. ",time-usec=0,latitude=" ..
        latitude .. ",longitude=" .. longitude, 0, false);
      mqttPublish(mqtt_client, "com.mycar2.revolution", "value=" .. rpm ..
        ",time-sec=" .. timeS .. ",time-usec=0,latitude=" ..
        latitude .. ",longitude=" .. longitude, 0, false);
      mqttPublish(mqtt_client, "com.mycar2.acceleration_x", "value=" ..
        accel_x .. ",time-sec=" .. timeS ..
        ",time-usec=0,latitude=" .. latitude .. ",longitude=" ..
        longitude, 0, false);
      mqttPublish(mqtt_client, "com.mycar2.acceleration_y", "value=" ..
        accel_y .. ",time-sec=" .. timeS ..
        ",time-usec=0,latitude=" .. latitude .. ",longitude=" ..
        longitude, 0, false);
      mqttPublish(mqtt_client, "com.mycar2.acceleration_z", "value=" ..
        accel_z .. ",time-sec=" .. timeS ..
        ",time-usec=0,latitude=" .. latitude .. ",longitude=" ..
        longitude, 0, false);

      if latitude ~= 0 and longitude ~= 0 then

        kph_event = kph;
        mpg_event = mpg;
        rpm_event = rpm;
        longitude_event = longitude;
        latitude_event = latitude;
        time_event = timeS

        sendSMS(event_number);
        tagSetNum("enable_incident", 0)
        timerStart ("incident.timer", incident_timer);
        timerStart ("report_event.timer", report_timer);
      --              mqttPublish(mqtt_client,"com.mycar2.mycar_data","value=kph="..kph.."/rpm="..rpm.."/mpg="..mpg.."/event=0,time-sec="..timeS..",time-usec=0,latitude="..latitude..",longitude="..longitude,0,false);
      end
      --            digiDefineFloat ("event_data", "kph/rpm/mpg/event/time/longitud/latitude", "datas", 3, 3);
      --            tagSetNum("event_data", "kph="..kph.."/rpm="..rpm.."/mpg="..mpg.."/event=1/time="..name.."longitude="..longitude.."latitude="..latitude)
    end

    tagSetString("mycar_data", "kph=" .. kph .. "/rpm=" .. rpm .. "/mpg=" ..
      mpg .. "/event=0/time=" .. timeS .. "/longitude=" ..
      longitude .. "/latitude=" .. latitude)
  end
end

function step(event)

  timerStart ("iio.timer", 1000);
  iioStep();
  local kph = tonumber(tagGetNum ("mycar_ii_kph"));
  tagSetNum("mycar_ii_kph_2s",kph);
  local rpm = tonumber(tagGetNum ("mycar_ii_rpm"));
  tagSetNum("mycar_ii_rpm_2s",rpm);
end


--! \brief  step function for local data processing - none required for my car
function kph_function (event)

  local kph = tonumber(tagGetNum ("mycar_ii_kph_2s"));
  local limit_kph = tonumber(tagGetNum("threshold_speed"));

  print(kph .. " km/h" .. " (limit " .. limit_kph .. " km/h)")

  if kph > limit_kph then
    incident(event)
  end

end
function mpg (event)

  local mpg = tagGetNum ("mycar_ii_mpg");
  print (mpg .." mpg")
end

function rpm_function (event)

  local rpm = tagGetNum ("mycar_ii_rpm_2s");

  print (rpm .. " rpm")
  limit_rpm = tagGetNum("threshold_rpm");

  if rpm > limit_rpm then
    incident(event)
  end
end

function breaking (event)

  local breaking = tagGetNum ("mycar_ii_braking_limit");
  print ("breaking is " .. breaking.."\n")
end

function accel (event)

  local accel_x = tagGetNum("accel_x");
  local accel_y = tagGetNum("accel_y");
  local accel_z = tagGetNum("accel_z");
  local threshold_accel = tagGetNum("threshold_acceleration");
  --   print("accel_x"..accel_x);
  --   print("accel_y"..accel_y);
  --   print("accel_z"..accel_z);
  --   print("threshold_acceleration"..threshold_accel);

  accel = math.abs(1024 - math.sqrt(accel_x^2 + accel_y^2 + accel_z^2))

  print(string.format("Accelerometer %.2f", accel))

  if accel > accel_threshold then
    if accel_event_triggered then
      accel_event_triggered = false
    else
      incident("accelerometer_event")
    end
  end
end

function speed (event)

  local speed = tagGetNum ("mycar_ii_speed_limit");
  print ("breaking is " .. speed.."\n")
end

function check_sms (event)

  timerStart ("modem.timer", 100000);
  gsmModemPoll();
end

function reenable_incidents(event)

  tagSetNum("enable_incident", 1)
end

function enable_report(event)

  tagSetNum("flag_video", 1);
end


function reenable_sms(event)
  sms_enabled = 1
end


--! \brief Start time to event and connect to the server.
function main (void)

  tagSetNum("flag_video", 0);
  initVideo("flag_video", "/dev/video0");
  tagSetString("name_file", "test");
  tagSetEvent("name_file", "name_file_new");
  eventHandler("name_file_new", send_file)
  eventHandler("sms_fallback_timer", reenable_sms)

  --publish function
  timerStart ("update1m.timer", 30000);
  eventHandler("update1m.timer", data_update_1m)

  eventHandler("incident.timer", reenable_incidents);
  eventHandler("report_event.timer", enable_report);
  tagSetNum("enable_incident", 1)
  tagSetNum("threshold_speed", kph_threshold);
  tagSetNum("threshold_rpm", rpm_threshold);
  tagSetNum("threshold_acceleration", accel_threshold);
  digiConnect("login.etherios.com", 0x0300029D, "My car Monitor Data",
    "Emutex VXF Lab drive Monitor", hwaddr);
  tagSetNum("string_digi", "kph");
  digiDefineFloat ("mycar_data", "kph/rpm/mpg/event/time/longitud/latitude", "String", 40,1);
  --    digiDefineFloat ("string_digi", "kph/rpm/mpg/event/time/longitud/latitude", "String", 3, 3);
  iioDefineInput("accel_x",
    "/sys/bus/iio/devices/iio:device0/in_accel_x_raw",
    "/sys/bus/iio/devices/iio:device0/in_accel_x_scale");
  iioDefineInput("accel_y",
    "/sys/bus/iio/devices/iio:device0/in_accel_y_raw",
    "/sys/bus/iio/devices/iio:device0/in_accel_y_scale");
  iioDefineInput("accel_z",
    "/sys/bus/iio/devices/iio:device0/in_accel_z_raw",
    "/sys/bus/iio/devices/iio:device0/in_accel_z_scale");
  timerStart("gps.timer", 10000);
  timerStart("iio.timer", 1000);
  eventHandler("iio.timer", step);
  eventHandler("gps.timer", pollGPS);
  tagSetEvent("accel_x", "accelerometer_event");
  eventHandler("accelerometer_event", accel);
  tagSetEvent("mycar_ii_kph_2s", "mycar_ii_kph_event");
  eventHandler("mycar_ii_kph_event", kph_function);
  tagSetEvent ("mycar_ii_rpm_2s", "mycar_ii_rpm_event");
  eventHandler("mycar_ii_rpm_event", rpm_function);
  thread("utils/announce")
  while 1 do
    local event2 = eventWait ();
    eventDispatch (event2);
  end
end

main ()
