-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

libOpen ("xbee.so.1.0", "/dev/ttyUSB0")

libOpen ("gpio.so.1.0");
libOpen ("iio.so.1.0");
libOpen ("rfid.so.1.0");
libOpen ("modbus.so.1.0");

-- Script the mysensors

local pirTime = 20000;

-- Define addresses of radios we will use

local radioRelayProduction = "0013A20040B40D66"
local radioWarehouse  = "0013A2004089BF91"
local radioProduction  = "0013A20040A61865"
local radioReception  = "0013A20040B40D63"
local radioAccountsoffice  = "0013A20040B40D02"
local radioBoardroom  = "0013A20040B40D16"
local radioEngineeringoffice  = "0013A20040B40D09"
local Mode_occupied = 0
local Mode_unoccupied = 1

-- map inputs to remote relay outputs
output = {}
output["xbee.reception.timer"] = 1
output["xbee.accountsoffice.timer"] = 2
output["xbee.boardroom.timer"] = 3
output["xbee.engineeringoffice.timer"] = 4

output["xbee.reception.pir"] = 1
output["xbee.accountsoffice.pir"] = 2
output["xbee.boardroom.pir"] = 3
output["xbee.engineeringoffice.pir"] = 4

--tampers
output["receptiondoor_access"]=1;
output["engineeringofficedoor_access"]=2;
output["productiondoor_access"]=3;
output["warehousedoor_access"]=4;
output["receptionwindow_tamper"]=0;
output["engineeringofficewindow_tamper"]=0;
output["productionwindow_tamper"]=0;
output["warehousewindow_tamper"]=0;


function pirOffTimer (event)

    -- pir = strsub(event, 1, 14)
    pir = event
    print ("PIR: get output for " .. pir)
    place = output[pir]

    print ("PIR: setting " .. place .. " from " .. pir .. " to off")
    if (place==1) then 
        tagSetNum("alarmpanel_modbusled3",0);
    elseif(place==2) then 
         tagSetNum("alarmpanel_modbusled4",0);
    elseif(place==3) then 
          tagSetNum("alarmpanel_modbusled5",0);
    elseif(place==4) then 
          tagSetNum("alarmpanel_modbusled6",0);
    end

end

function time_alarm(event)
     tagSetNum("alarmpanel_buzzer",0)
    tagSetNum("alarm_sig",0);
      tagSetNum("alarmpanel_leddisplaysign",0)

end


function buzzer_off(event)
     tagSetNum("alarmpanel_buzzer",0)

end


function  tamperChange (tag)
    name=string.gsub(tag,".event","");
    print ("tag " .. name .. " is " .. tagGetNum(name))
    value=tagGetNum(name);
    place=output[name];
    alarm=tagGetNum("alarm_sig");
    --Publish data
      if(name=="receptiondoor_access") then 
            tagSetNum("switch1",value)
      elseif (name=="engineeringofficedoor_access" ) then 
            tagSetNum("switch2",value)
      elseif (name=="productiondoor_access" ) then 
            tagSetNum("switch3",value)
      elseif (name=="warehousedoor_access" ) then 
            tagSetNum("switch4",value)
      elseif (name=="receptionwindow_tamper" ) then 
            tagSetNum("switch5",value)
      elseif (name=="engineeringofficewindow_tamper" ) then 
            tagSetNum("switch6",value)
      elseif (name=="productionwindow_tamper" ) then 
            tagSetNum("switch7",value)
      elseif (name=="warehousewindow_tamper" ) then 
            tagSetNum("switch8",value)
      end
      if ((mode == Mode_occupied)) then
            if (place==1) then 
               tagSetNum("alarmpanel_modbusled3",value);
            elseif(place==2) then 
               tagSetNum("alarmpanel_modbusled4",value);
            elseif(place==3) then 
               tagSetNum("alarmpanel_modbusled5",value);
            elseif(place==4) then 
               tagSetNum("alarmpanel_modbusled6",value);
            end
       elseif( (value==1) and (alarm==0)) then 
            if (place==0) then 
                tagSetNum("alarmpanel_buzzer",1)
                timerStart("timer_buzzer", 5000);
                --Put on displya modbus 
                tagSetNum("alarmpanel_leddisplaysign",1);      
                timerStart("Alarm", 10000);
             end

       end


end


function pirChange (tag)

    name=string.gsub(tag,".event","");
    print ("tag " .. name .. " is " .. tagGetNum(name))
    
    local pir = tagGetNum (name)
    place=string.gsub(string.gsub(tag,".pir.event","_movement"), "xbee.","");
     tagSetNum(place, pir);

    -- Get the mode.  0 is occupied and 1 unocupied
    local mode = tagGetNum ("factory_mode")
    print("mode "..mode.."\n");
    timer=string.gsub(tag,"pir.event","timer");
     place=output[name];
    alarm=tagGetNum("alarm_sig");

    if (pir ==0) then
        tagSetNum("AnyPIR",0);
        if (mode == Mode_occupied) then
            -- Otherwise, turn on the light and stop the off timer to turn
            -- it off again.
            print ("PIR: get output for " .. pir)
            timerStop (timer)
            --turn on light modbus
            if (place==1) then 
               tagSetNum("alarmpanel_modbusled3",1);
            elseif(place==2) then 
               tagSetNum("alarmpanel_modbusled4",1);
            elseif(place==3) then 
               tagSetNum("alarmpanel_modbusled5",1);
            elseif(place==4) then 
               tagSetNum("alarmpanel_modbusled6",1);
            end
           --turn on light
        elseif (alarm==0) then
           tagSetNum("alarmpanel_buzzer",1)
            --Put on displya modbus 
           tagSetNum("alarmpanel_leddisplaysign",1);      
           timerStart("Alarm", 10000);
        end
       
    else
        tagSetNum("AnyPIR",1);
        if (mode == Mode_occupied) then
            timerStart (timer, pirTime)
        end
    end
end

function tempChange (tag)
    name=string.gsub(tag,".event","");
    print ("tag " .. name .. " is " .. tagGetNum(name))
    local xbee = require "utils/xbee"
    temp=xbee.temp(name)
    place=string.gsub(string.gsub(tag,".temp.event","_temperature"), "xbee.","");
    tagSetNum(place, temp);
 
end

function tempChange2 (tag)
    print("tempChange2\n");
    name=string.gsub(tag,".event","");

    print ("tag " .. name .. " is " .. tagGetNum(name))
    local xbee = require "utils/xbee"
    temp_c=xbee.tempXbee(name)
    val, timeS, timeU = tagGetNumValueTime (name)
    print("*********Temperature = "..temp_C.."\n");

    if (name=="xbee.warehouse.temp") then
         dbInsert("INSERT INTO warehouse_temperature ( temperature, time) values("..temp_C..","..timeS..");")
          tagSetNum("warehouse_temperature", temp_C);
     elseif (name=="xbee.production.temp") then 
         dbInsert("INSERT INTO production_temperature ( temperature, time) values("..temp_C..","..timeS..");")
          tagSetNum("production_temperature", temp_C);
    end


end

function lightChange (tag)
    print("lightChange\n");
    name=string.gsub(tag,".event","");

    print ("tag " .. name .. " is " .. tagGetNum(name))
    local xbee = require "utils/xbee"
    brightness = xbee.light(name)
    print("*********brightness  = "..brightness.."\n");
    if (name=="xbee.warehouse.light") then
          tagSetNum("warehouse_lightlevel", brightness);
    elseif (name=="xbee.production.light") then 
          tagSetNum("production_ambientlightlevel", brightness);
    end 
           
end
function humChange (tag)
    print("humChange\n");
    name=string.gsub(tag,".event","");

    print ("tag " .. name .. " is " .. tagGetNum(name))
    local xbee = require "utils/xbee"
    local hum  = xbee.humity(name)

    print("*********humidity  = "..hum.."\n");
    if (name=="xbee.warehouse.hum") then
          tagSetNum("warehouse_humidity", hum);
    elseif (name=="xbee.production.hum") then 
          tagSetNum("production_humidity", hum);
    end 
           
end
function switchgpio(tag)

   print("**GPIO Switch\n");
    name=string.gsub(tag,".event","");

    print ("tag " .. name .. " is " .. tagGetNum(name))
    val = tagGetNum (name)
     alarm=tagGetNum("alarm_sig");
    if (val==1) then 
        if(name=="production_smokedetector") then 
             tagSetNum("alarmpanel_modbusled7",1)
             tagSetNum("switchA",1)
             print("***Smoke detector switched on***")
        else
             tagSetNum("switchB",1)
             tagSetNum("alarmpanel_modbusled8",1)
             print("***CO2 detector switched on***")
        end
        if (alarm==0) then 
            tagSetNum("alarmpanel_buzzer",1)
            timerStart("timer_buzzer", 5000);
            --Put on displya modbus       
            tagSetNum("alarmpanel_leddisplaysign",1)
            tagSetNum("alarm_sig",1);
            timerStart("Alarm", 10000);
         end
    else
        if(name=="production_smokedetector") then 
             tagSetNum("switchA",0)
             tagSetNum("alarmpanel_modbusled7",0)
             print("***Smoke detector switched off***")
        else
             tagSetNum("switchB",0)
             tagSetNum("alarmpanel_modbusled8",0)
             print("***CO2 detector switched off***")
        end
      --  end
    end
             


end

function noise (event)
--   print("Value voltage "..tagGetNum("AIN5"));
   volt,timeS, timeU=tagGetNumValueTime("AIN5")
   --put in variable of noise
   tagSetNum("production_ambientnoise", volt);
  
   dbInsert("INSERT INTO production_ambientnoise ( voltage, time) values("..volt..","..timeS..");")
   alarm=tagGetNum("alarm_sig");
   mode= tagGetNum("factory_mode");
   threshold= tagGetNum("threshold_noise");
   if ((volt>threshold)and (mode==Mode_unoccupied)and (alarm==0)) then 
         tagSetNum("alarmpanel_buzzer",1)
         --Put on displya modbus       
         timerStart("Alarm", 10000);
         timerStart("timer_buzzer", 5000);
         tagSetNum("alarm_sig",1);
         --put on display
         tagSetNum("alarmpanel_leddisplaysign",1);
       
   end
  

end


function temp_productionroom (event)
--   print("Value voltage AIN4"..tagGetNum("AIN4"));
   threshold=tagGetNum("AIN4")
   --put in variable of noise
  tagSetNum("productionroom_temperatureset", threshold);
  temperature=tagGetNum("production_temperature");
  if ((temperature*25.9)>threshold) then 
     tagSetNum("production_coolingfan",1);
  else
     tagSetNum("production_coolingfan",0);
  end
     
end

function traffic_light(event)

   print("Signal Traffic light "..tagGetNum("alarmpanel_trafficlight"));
   option=tagGetNum("alarmpanel_trafficlight");
   if (option == 0) then 
      tagSetNum("traffic_light_green",1);
      tagSetNum("traffic_light_yellow",0);
      tagSetNum("traffic_light_red",0);
   elseif (option == 1) then 
      tagSetNum("traffic_light_green",0);
      tagSetNum("traffic_light_yellow",1);
      tagSetNum("traffic_light_red",0);
   elseif (option == 2) then 
      tagSetNum("traffic_light_green",0);
      tagSetNum("traffic_light_yellow",0);
      tagSetNum("traffic_light_red",1);
   end

end

function rfid_indentify(event)
   code=tagGetString("rfid");

   print("RFID with code "..code);
   start_code,end_code=string.find(code, "6F005C723978");
   if(end_code~=nil) then 
      print("Mark has scanned in");
      tagSetNum("building_access",0);
   else 
      print("Joe has scanned in");
      tagSetNum("building_access",1);
   end

end


function level_noise_change (tag)
    name=string.gsub(tag,".event","");

    print ("tag " .. name .. " is " .. tagGetNum(name))
   
   value= tagGetNum(name);
   if(value==1) then 
      tagSetNum("threshold_noise", 5);
   elseif (value==2) then 
      tagSetNum("threshold_noise", 1000);
   elseif (value==3) then 
      tagSetNum("threshold_noise", 1500);
   elseif (value==4) then 
      tagSetNum("threshold_noise", 2000);
   end

end

function production_light_func(event)

   val=tagGetNum ("production_light");
   local xbee = require "utils/xbee"

   xbee.setRelay(radioRelayProduction,1,val);

      

end

function change_mode (tag)

   local xbee = require "utils/xbee"
   print("Changed mode\n");
   print ("tag " .. tag .. " is " .. tagGetNum("factory_mode"))
   val = tagGetNum ("factory_mode")
   if (val==0) then 
      xebee.setRelay(radioRelayProduction,1,1);
   else
      print("Set Relay 0\n");
      xebee.setRelay(radioRelayProduction,1,0);
   end

end

function step (event)
    timerStart ("xbee.timer", 1000);
    iioStep();
    gpioStep ();
--    modbusStep();
    modbusUpdate();
    -- relayTest ()
--   xbeeStep ();
end

tagSetNum("factory_mode",1);
--tagSetNum("factory_mode",0);
tagSetNum("AnyPIR",1);
tagSetNum("publish_data",1);
tagSetNum("AnyTamper",0);
tagSetNum("alarm_sig",0);
tagSetNum("threshold_noise",1500);
tagSetNum("threshold_temp",600);
timerStart ("xbee.timer", 1000);

-- define a new xbee device by 64-bit address, with tag xbee.remote1
xbeeDefineDataDevice (radioRelayProduction, "xbee.relayProduction");
xbeeDefineIoDevice (radioWarehouse, "xbee.warehouse");
xbeeDefineIoDevice (radioProduction, "xbee.production");
xbeeDefineIoDevice (radioReception, "xbee.Reception");
xbeeDefineIoDevice (radioAccountsoffice, "xbee.accountsoffice");
xbeeDefineIoDevice (radioBoardroom, "xbee.boardroom");
xbeeDefineIoDevice (radioEngineeringoffice, "xbee.engineeringoffice");

-- define digital pin 3 on the remote nodes as digital pir inputs
xbeeDefineDigitalInput (radioReception, 3, 0, "xbee.reception.pir");
xbeeDefineDigitalInput (radioAccountsoffice, 3, 0, "xbee.accountsoffice.pir");
xbeeDefineDigitalInput (radioBoardroom, 3, 0, "xbee.boardroom.pir");
xbeeDefineDigitalInput (radioEngineeringoffice, 3, 0, "xbee.engineeringoffice.pir");

-- define digital pin 2 on the remote nodes as analog temperature inputs
xbeeDefineAnalogInput (radioWarehouse, 1, 0, "xbee.warehouse.light");
xbeeDefineAnalogInput (radioWarehouse, 2, 0, "xbee.warehouse.temp");
xbeeDefineAnalogInput (radioWarehouse, 3, 0, "xbee.warehouse.hum");
xbeeDefineAnalogInput (radioProduction, 1, 0, "xbee.production.light");
xbeeDefineAnalogInput (radioProduction, 2, 0, "xbee.production.temp");
xbeeDefineAnalogInput (radioProduction, 3, 0, "xbee.production.hum");
xbeeDefineAnalogInput (radioReception, 2, 0, "xbee.reception.temp");
xbeeDefineAnalogInput (radioAccountsoffice, 2, 0, "xbee.accountsoffice.temp");
xbeeDefineAnalogInput (radioBoardroom, 2, 0, "xbee.boardroom.temp");
xbeeDefineAnalogInput (radioEngineeringoffice, 2, 0, "xbee.engineeringoffice.temp");


-- Set up traps for any change of any pir sensor
tagSetEvent ("xbee.reception.pir", "xbee.reception.pir.event");
eventHandler ("xbee.reception.pir.event", pirChange);
tagSetEvent ("xbee.accountsoffice.pir","xbee.accountsoffice.pir.event" );
eventHandler ("xbee.accountsoffice.pir.event", pirChange);
tagSetEvent ("xbee.boardroom.pir", "xbee.boardroom.pir.event");
eventHandler ("xbee.boardroom.pir.event", pirChange);
tagSetEvent ("xbee.engineeringoffice.pir","xbee.engineeringoffice.pir.event");
eventHandler ("xbee.engineeringoffice.pir.event", pirChange);

-- Set up traps for any change of any temp sensor
tagSetEvent ("xbee.reception.temp", "xbee.reception.temp.event");
eventHandler ("xbee.reception.temp.event", tempChange);
tagSetEvent ("xbee.accountsoffice.temp","xbee.accountsoffice.temp.event" );
eventHandler ("xbee.accountsoffice.temp.event", tempChange);
tagSetEvent ("xbee.boardroom.temp", "xbee.boardroom.temp.event");
eventHandler ("xbee.boardroom.temp.event", tempChange);
tagSetEvent ("xbee.engineeringoffice.temp","xbee.engineeringoffice.temp.event");
eventHandler ("xbee.engineeringoffice.temp.event",tempChange);

-- timers for PIR off to debounce the PIR inputs
eventHandler ("xbee.reception.timer", pirOffTimer);
eventHandler ("xbee.accountsoffice.timer", pirOffTimer);
eventHandler ("xbee.boardroom.timer", pirOffTimer);
eventHandler ("xbee.engineeringoffice.timer", pirOffTimer);

eventHandler("Alarm",time_alarm);
eventHandler("timer_buzzer",buzzer_off);

-- manger new zigbee sensor
tagSetEvent ("xbee.warehouse.light","xbee.warehouse.light.event" );
eventHandler ("xbee.warehouse.light.event", lightChange);
tagSetEvent ("xbee.warehouse.temp","xbee.warehouse.temp.event" );
eventHandler ("xbee.warehouse.temp.event", tempChange2);
tagSetEvent ("xbee.warehouse.hum","xbee.warehouse.hum.event" );
eventHandler ("xbee.warehouse.hum.event", humChange);
tagSetEvent ("xbee.production.light","xbee.production.light.event" );
eventHandler ("xbee.production.light.event", lightChange);
tagSetEvent ("xbee.production.temp","xbee.production.temp.event" );
eventHandler ("xbee.production.temp.event", tempChange2);
tagSetEvent ("xbee.production.hum","xbee.production.hum.event" );
eventHandler ("xbee.production.hum.event", humChange);


-- enable gpio switch
gpioDefineInput ("production_smokedetector", 38);
tagSetEvent ("production_smokedetector","production_smokedetector.event" );
eventHandler ("production_smokedetector.event",switchgpio);

--gpioDefineInput ("production_CO2detector", 34);
gpioDefineInput ("production_CO2detector", 45);
tagSetEvent ("production_CO2detector","production_CO2detector.event" );
eventHandler ("production_CO2detector.event",switchgpio);

--enable iio sensor

iioDefineInput("AIN5","/sys/devices/ocp.3/helper.10/AIN5", "empty");
iioDefineInput("AIN4","/sys/devices/ocp.3/helper.10/AIN4", "empty");


tagSetEvent ("AIN5", "noise_event");
eventHandler ("noise_event",  noise);

tagSetEvent ("AIN4", "temp_productionroom_event");
eventHandler ("temp_productionroom_event", temp_productionroom);

-- assign a timer handler
eventHandler ("xbee.timer", step);

-- define actuator

gpioDefineOutput ("production_coolingfan", 48);
gpioDefineOutput ("alarmpanel_buzzer", 7);
--Define traffic light 
gpioDefineOutput ("traffic_light_yellow",115);
gpioDefineOutput ("traffic_light_red",117);
gpioDefineOutput ("traffic_light_green",49 );
tagSetNum("traffic_light_green",1);
tagSetNum("alarmpanel_trafficlight",1);


tagSetEvent("alarmpanel_trafficlight", "traffic_light_event");
eventHandler("traffic_light_event", traffic_light);

tagSetEvent("factory_mode", "change_mode_event")
eventHandler("change_mode_event", change_mode);
tagSetEvent("level_noise", "level_noise.event")
eventHandler("level_noise.event",level_noise_change );
tagSetNum("level_noise",3);

tagSetEvent("production_light", "production_light.event");
eventHandler("production_light.event", production_light_func);

--Define modbus
local MODBUS_DATA_FMT_BIT   =   7; -- device_address single bit value (may not be necessary)
modbus_fd = modbusRtuOpen ("/dev/ttyO2");
modbusRegisterDevice ("ADAM4055", 1, 10);
modbusDefineDataRange (1, 0x00, 0x07,MODBUS_DATA_FMT_BIT,0,10);
--input
modbusDefineDataPoint (1, 0x00, "receptiondoor_access");
modbusDefineDataPoint (1, 0x01, "engineeringofficedoor_access");
modbusDefineDataPoint (1, 0x02, "productiondoor_access");
modbusDefineDataPoint (1, 0x03, "warehousedoor_access");
modbusDefineDataPoint (1, 0x04, "receptionwindow_tamper");
modbusDefineDataPoint (1, 0x05, "engineeringofficewindow_tamper");
modbusDefineDataPoint (1, 0x06, "productionwindow_tamper");
modbusDefineDataPoint (1, 0x07, "warehousewindow_tamper");
tagSetEvent("receptiondoor_access", "receptiondoor_access.event");
tagSetEvent("engineeringofficedoor_access", "engineeringofficedoor_access.event");
tagSetEvent("productiondoor_access", "productiondoor_access.event");
tagSetEvent("warehousedoor_access", "warehousedoor_access.event");
tagSetEvent("receptionwindow_tamper", "receptionwindow_tamper.event");
tagSetEvent("engineeringofficewindow_tamper", "engineeringofficewindow_tamper.event");
tagSetEvent("productionwindow_tamper", "productionwindow_tamper.event");
tagSetEvent("warehousewindow_tamper", "warehousewindow_tamper.event");
eventHandler("receptiondoor_access.event", tamperChange);
eventHandler("engineeringofficedoor_access.event", tamperChange);
eventHandler("productiondoor_access.event", tamperChange);
eventHandler("warehousedoor_access.event", tamperChange);
eventHandler("receptionwindow_tamper.event", tamperChange);
eventHandler("engineeringofficewindow_tamper.event", tamperChange);
eventHandler("productionwindow_tamper.event", tamperChange);
eventHandler("warehousewindow_tamper.event", tamperChange);

--output
modbusDefineDataRange (1, 0x10, 0x17,MODBUS_DATA_FMT_BIT,1,10);
modbusDefineDataPoint (1, 0x10, "alarmpanel_modbusled1"); -- actually led1
modbusDefineDataPoint (1, 0x11, "alarmpanel_leddisplaysign");
modbusDefineDataPoint (1, 0x12, "alarmpanel_modbusled3");
modbusDefineDataPoint (1, 0x13, "alarmpanel_modbusled4");
modbusDefineDataPoint (1, 0x14, "alarmpanel_modbusled5");
modbusDefineDataPoint (1, 0x15, "alarmpanel_modbusled6");
modbusDefineDataPoint (1, 0x16, "alarmpanel_modbusled7");
modbusDefineDataPoint (1, 0x17, "alarmpanel_modbusled8");
tagSetNum("alarmpanel_modbusled1",0);
tagSetNum("alarmpanel_leddisplaysign",0);
tagSetNum("alarmpanel_modbusled3",0);
tagSetNum("alarmpanel_modbusled4",0);
tagSetNum("alarmpanel_modbusled5",0);
tagSetNum("alarmpanel_modbusled6",0);
tagSetNum("alarmpanel_modbusled7",0);
tagSetNum("alarmpanel_modbusled8",0);
  
-- Define RFID

rfidSetup("/dev/ttyUSB1","rfid")
tagSetEvent("rfid", "rfid_event")
eventHandler("rfid_event", rfid_indentify)
thread("apps/mysensors/publish")

while 1 do
    local event = eventWait ();
    eventDispatch (event);
end
