-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

local announce = require "utils/announce"




function data_movement_update(event)

    publish_flag= tagGetNum("publish_data")
    
    if(publish_flag ==1) then 
        if (event== "reception_movement_event") then 
            announce.publish("reception_movement") 
       elseif (event== "accountsoffice_movement_event") then
           announce.publish("accountsoffice_movement") 
       elseif (event== "boardroom_movement_event") then 
           announce.publish("boardroom_movement") 
       else
           announce.publish("engineeringoffice_movement") 
       end
    end

end

function data_rfid_update (event)

    publish_flag= tagGetNum("publish_data")
    if(publish_flag ==1) then 
        bval,timeS,timeU = tagGetNumValueTime ("building_access") 
        if (bval==0) then 
           mqttPublish(0,"com.bbelec.factory1.building.access","value=Mark,time-sec="..timeS..",time-usec="..timeU,0,false);
        else
           mqttPublish(0,"com.bbelec.factory1.building.access","value=Joe,time-sec="..timeS..",time-usec="..timeU,0,false);
        end
    end

end

function switch_update(event)
    publish_flag= tagGetNum("publish_data")
    if(publish_flag ==1) then 
   
        name=string.gsub(event,".event","");
        
        if(name=="switch1") then 
           announce.publish ("receptiondoor_access") 

        elseif(name=="switch2") then 
           announce.publish("engineeringofficedoor_access") 
        elseif(name=="switch3") then 
           announce.publish("productiondoor_access") 
        elseif(name=="switch4") then 
           announce.publish("warehousedoor_access") 
        elseif(name=="switch5") then 
           announce.publish("receptionwindow_tamper") 
        elseif(name=="switch6") then 
           announce.publish("engineeringofficewindow_tamper") 
        elseif(name=="switch7") then 
           announce.publish("productionwindow_tamper") 
        elseif(name=="switch8") then 
           announce.publish ("warehousewindow_tamper") 
        elseif(name=="switchA") then 
           announce.publish("production_smokedetector") 
        elseif(name=="switchB") then 
           announce.publish ("production_CO2detector") 
        end
    end

end

function data_update_1s (event)
    timerStart ("update1s.timer", 900000);


    publish_flag= tagGetNum("publish_data")
    if(publish_flag ==1) then 

        announce.publish("productionroom_temperatureset") 
    end

end

function data_update_1m (event)
    timerStart ("update1m.timer", 60000);

    publish_flag= tagGetNum("publish_data")
    if(publish_flag ==1) then 
        announce.publish("warehouse_temperature") 

        announce.publish("production_temperature") 
    end
end

function data_update_5m (event)
    timerStart ("update5m.timer", 300000);

    publish_flag= tagGetNum("publish_data")
    if(publish_flag ==1) then 
        announce.publish("reception_temperature") 
        announce.publish("accountsoffice_temperature") 
        announce.publish("boardroom_temperature") 
        announce.publish ("engineeringoffice_temperature") 
        announce.publish("warehouse_lightlevel") 
        announce.publish("production_ambientlightlevel") 
        announce.publish("warehouse_humidity") 
        announce.publish ("production_humidity") 
        announce.publish ("production_ambientnoise") 
    end

end
function data_update_1h (event)
    timerStart ("update1h.timer", 1800000);
    publish_flag= tagGetNum("publish_data")
   -- Get the last value of temperarature  
    bval,timeS,timeU = tagGetNumValueTime ("warehouse_temperature")
    --Get AVG temperature last 8 hours
    
    result=dbQueryColum("select avg(temperature) from warehouse_temperature where time>"..(timeS-1800)..";","avg(temperature)");
    if ((type(result)=='number') and (publish_flag==1))then
       tagSetNum("warehouse_averagetemperature",result);
       mqttPublish(0,"com.bbelec.factory1.warehouse.averagetemperature","value="..result..",time-sec="..timeS..",time-usec="..timeU,0,false);
    end

    dbInsert("DELETE from  warehouse_temperature where time<"..(timeS-1800)..";");

   -- Get the last value of temperarature  
    bval,timeS,timeU = tagGetNumValueTime ("production_temperature")
    --Get AVG temperature last 8 hours
    
    result=dbQueryColum("select avg(temperature) from production_temperature where time>"..(timeS-1800)..";","avg(temperature)");
    if ((type(result)=='number')and (publish_flag==1)) then
        tagSetNum("production_averagetemperature",result);
        mqttPublish(0,"com.bbelec.factory1.production.averagetemperature","value="..result..",time-sec="..timeS..",time-usec="..timeU,0,false);
    end

    dbInsert("DELETE from  production_temperature where time<"..(timeS-1800)..";");

   -- Get the last value of noise  
    bval,timeS,timeU = tagGetNumValueTime ("production_ambientnoise")
    --Get AVG temperature last 8 hours
    
    result=dbQueryColum("select avg(voltage) from production_ambientnoise where time>"..(timeS-1800)..";","avg(voltage)");
    print("Result= "..result.."\n");
    if ((type(result)=='number') and (publish_flag==1)) then
        tagSetNum("production_averageambientnoise",result);
        mqttPublish(0,"com.bbelec.factory1.production.averageambientnoise","value="..result..",time-sec="..timeS..",time-usec="..timeU,0,false);
    end

    dbInsert("DELETE from production_ambientnoise where time<"..(timeS-1800)..";");


end


thread("utils/announce")
timerStart ("update1s.timer", 900000);

eventHandler ("update1s.timer", data_update_1s);

timerStart ("update1m.timer", 60000);

eventHandler ("update1m.timer", data_update_1m);
timerStart ("update5m.timer", 300000);

eventHandler ("update5m.timer", data_update_5m);

timerStart ("update1h.timer", 1800000);

eventHandler ("update1h.timer", data_update_1h);

tagSetEvent ("reception_movement","reception_movement_event" );
eventHandler ("reception_movement_event",data_movement_update);

tagSetEvent ("accountsoffice_movement","accountsoffice_movement_event" );
eventHandler ("accountsoffice_movement_event",data_movement_update);

tagSetEvent ("boardroom_movement","boardroom_movement_event" );
eventHandler ("boardroom_movement_event",data_movement_update);

tagSetEvent ("engineeringoffice_movement","engineeringoffice_movement_event" );
eventHandler ("engineeringoffice_movement_event",data_movement_update);

tagSetEvent ("building_access","building_access_event" );
eventHandler ("building_access_event",data_rfid_update);

tagSetEvent ("switch1","switch1.event" );
eventHandler ("switch1.event",switch_update);

tagSetEvent ("switch2","switch2.event" );
eventHandler ("switch2.event",switch_update);

tagSetEvent ("switch3","switch3.event" );
eventHandler ("switch3.event",switch_update);

tagSetEvent ("switch4","switch4.event" );
eventHandler ("switch4.event",switch_update);

tagSetEvent ("switch5","switch5.event" );
eventHandler ("switch5.event",switch_update);

tagSetEvent ("switch6","switch6.event" );
eventHandler ("switch6.event",switch_update);

tagSetEvent ("switch7","switch7.event" );
eventHandler ("switch7.event",switch_update);

tagSetEvent ("switch8","switch8.event" );
eventHandler ("switch8.event",switch_update);

tagSetEvent ("switchA","switchA.event" );
eventHandler ("switchA.event",switch_update);

tagSetEvent ("switchB","switchB.event" );
eventHandler ("switchB.event",switch_update);
