-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--! \file
--! \brief Module to connect to server  where data are put 

function foo (event)
end

--! \brief  function look at the values in modbus and put values in light and fan.
function step (event)
    timerStart ("digi.timer", 1000);

    local voltage = tagGetNum ("modbus.v-l1");
    local current_light = tagGetNum ("modbus.i-l2");
    local current_fan = tagGetNum ("modbus.i-l3");
    local Bedroom = tagGetNum ("Bedroom");
    local Boxroom = tagGetNum ("Boxroom");
    local Bathroom = tagGetNum ("Bathroom");
    local Lounge = tagGetNum ("Lounge");

    print ("voltage is " .. voltage ..
           ", current_light is " .. current_light ..
           ", current_fan is " .. current_fan ..
           ", Bedroom temp is " .. Bedroom ..
           ", Boxroom temp is " .. Boxroom ..
           ", Bathroom temp is " .. Bathroom ..
           ", Lounge temp is " .. Lounge .. "\n");


  -- tagSetNum ("LAB_voltage", voltage);
  -- tagSetNum ("LAB_current", current);

    tagSetNum ("LAB_Light", voltage * current_light);
    tagSetNum ("LAB_Fan", voltage * current_fan);

end
--! \brief Start time to event and connect to the server. The magnitude of LAB_ligth and LAB_fan is made.
function main (void)
    timerStart ("digi.timer", 1000);

    eventHandler ("digi.timer", step);
    -- eventHandler ("modbus.timer", foo);
--    digiConnect ("login.etherios.co.uk", 0x040000BD,"Energy Monitor Data","Emutex VXF Lab Energy Monitor", "00:13:20:FD:F6:E6");
    digiConnect ("login.etherios.com", 0x0300015A,"MyWatts Gen2","Mywatts Gen2", "98:4F:EE:01:68:6C");
    digiDefineFloat ("LAB_Light", "Lab_light/LAB_Light", "Watts", 3, 3);
    digiDefineFloat ("LAB_Fan", "Lab_fan/LAB_Fan", "Watts", 4, 3);
    digiDefineFloat ("Bedroom", "sensor/Bedroom", "Temp", 4, 3);
    digiDefineFloat ("Boxroom", "sensor/Boxroom", "Temp", 4, 3);
    digiDefineFloat ("Bathroom", "sensor/Bathroom", "Temp", 4, 3);
    digiDefineFloat ("Lounge", "sensor/Lounge", "Temp", 4, 3);

    while 1 do
        local event = eventWait ();
        -- local param = eventGetParam ();
        eventDispatch (event);
    end
end

main ()
