-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--! \file
--! \brief Module to connect to server where data are put 

-- This is an example file that fetches data from a local weather station
-- and pushes it to the cloud using the digi Etherios service.  This file
-- demonstrates some local processing of the weather values.

speed_values = {}
dir_values = {}

count = 0;
max = 0;

function step (event)
    timerStart ("digi.timer", 1000);

    local speed = tagGetNum ("weather_wind_speed");
    local direction = tagGetNum ("weather_wind_dir");

    print ("speed is " .. speed .. 
           ", dir is " .. direction .. "\n");

    speed_values[count] = speed;
    dir_values[count] = direction;

    count = count + 1;

    if (count > max) then
        max = count;
    end

    if (count == 10) then
        count = 0;
    end

    i = 0;

    local avg_speed = 0;
    local avg_dir = 0;

    print ("Calc avg");

    while (i < max) do
        avg_speed = avg_speed + speed_values[i];
        avg_dir = avg_dir + dir_values[i];
        i = i + 1
    end

    avg_speed = avg_speed / max;
    avg_dir = avg_dir * (360 / 16) / max;

    print ("set values");
    tagSetNum ("Wind_Speed", avg_speed);
    tagSetNum ("Wind_Direction", avg_dir);
    print ("done");
end

function main (void)
    timerStart ("digi.timer", 1000);

    eventHandler ("digi.timer", step);
    digiConnect ("login.etherios.co.uk", 0x04000081,"Weather Data",
                 "Emutex Weather", "00:16:76:c2:7c:71");
    digiDefineFloat ("Wind_Speed", "Wind_Speed/Wind_Speed", "knots", 3, 3);
    digiDefineFloat ("Wind_Direction", "Wind_Direction/Wind_Direction", "degrees", 4, 3);

    while 1 do
        local event = eventWait ();
        eventDispatch (event);
    end
end

main ()
