-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

libOpen("curl.so.1.0")
local config = require "utils/config"
local tags = require 'utils/tags'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local SCADA_PUBLISH = tags.getScadaPublish ()

eventHandler(SCADA_PUBLISH, function() end)

local function createURL(topic, value)
    local scadaServer, scadaPort = config.getScadaServer(vendorID, deviceID)
    return string.format("%s:%s/ScadaBR/httpds?%s=%s", scadaServer, scadaPort, topic, value)
end

while true do
    local event, param = eventWait()
    local paramTable = paramDecodeHeader (param)
    if event == SCADA_PUBLISH then
        local curl = curlInit()
        local url = createURL(paramTable.topic, paramTable.value)
        curlSetUrl(curl, url)
        curlRequest(curl, " ")
        curlCleanup(curl)
    else
        WARN("Unknown event " .. event .. " received in scada publish")
    end
end
