-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

local checkQuery = {}

function checkQuery.singleValue(value)
    if type(value) == "number" then
        return true
    elseif type(value) == "boolean" then
        return true
    elseif type(value) == "string" then
        return true
    else
        return false
    end
end

function checkQuery.singleColumn(column)
    if type(column) ~= "string" then
        return false
    end

    return column:match("[';]") == nil
end

function checkQuery.values(values)
    if type(values) ~= "table" then
        return false
    end

    for _, value in ipairs(values) do
        if not checkQuery.singleValue(value) then
            return false
        end
    end

    return true
end

function checkQuery.columns(columns)
    if type(columns) ~= "table" then
        return false
    end

    for _, column in ipairs(columns) do
        if not checkQuery.singleColumn(column) then
            return false
        end
    end

    return true
end

function checkQuery.columnValuePairs(columnValuePairs)
    if type(columnValuePairs) ~= "table" then
        return false
    end

    for column, value in pairs(columnValuePairs) do
        if not checkQuery.singleColumn(column) or
           not checkQuery.singleValue(value) then
            return false
        end
    end

    return true
end

return checkQuery
