-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: ADXL345
   Description: 3-axis accelerometer (13-bit)
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Node
   Platform: Generic
   Param1: STR "Bus"    "0"
   Param2: STR "Address" "0x1D"
--]]

local Adxl345 = require 'drivers/adxl345'
local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local bus = params[4]
local addr = params[5]
local adxlObj

if not bus or not addr then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local function updateADXL345()
    local mean = 0
    local x, y, z = adxlObj:getAxes()

    if x == nil or y == nil or z == nil then
        ERRORF ('Failed to read adxl345 %q', sensorID)
        return
    end

    sensorSet (sensorID .. '-x', x)
    sensorSet (sensorID .. '-y', y)
    sensorSet (sensorID .. '-z', z)
end

adxlObj = Adxl345.create(bus, addr)
-- if wasn't used before, enable
if tagGetNum(sensorID) == 0 then
    adxlObj:setBandwidth(adxlObj.BW_RATE_1600HZ)
    adxlObj:setRange(adxlObj.RANGE_16G)
    adxlObj:enableMeasurement()
end

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, updateADXL345, 1000)
