-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: BMF136 Data
   Description: Monitors up to 12 three phase circuits or 36 single phase circuits, or any combination of single or three phase circuits.
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Sensor
   Platform: Generic
   Param1: STR "Submetter"
   Param2: STR "Start address"
   Param3: STR "End address"
   Param4: STR "Register"
--]]

local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local submeter = params[4]
local startAddr = params[5]
local endAddr = params[6]
local register = params[7]

if not submeter or not startAddr or not endAddr or not register then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local function sendRegister ()
    local toSend = {
        submeter = submeter,
        startAddr = startAddr,
        endAddr = endAddr,
        register = register,
        tag = sensorID
    }
    local msg = paramEncode (toSend, 'csv')
    tagSetString('_bfm136register', msg)
end

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, sendRegister, 30000)
