-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: CoAp actuator
   Description: Send values to a remote CoAp actuator
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Actuator
   Platform: Generic
   Param1: STR "Address"
   Param2: STR "Device"
   Param2: STR "UID"
--]]

--! @file.
--! @brief Script for setting CoAp actuator value

libOpen("coap.so.1.0")

local utils = require 'utils/utils'
local deviceControl = require 'utils/device_control'

local params = { ... }

local vendor   = params[1]
local device   = params[2]
local sensorId = params[3]
local addr     = params[4]
local dev      = params[5]
local uid      = params[6]

local function sendValue (tag, value)
    NOTIFY ('Event, get tag ' .. tag)
    NOTIFY ('value is ' .. value)

    coapPut(addr, string.format("set/%s/actuator/%s", dev, uid), value)
end

deviceControl.loopActuatorThread(vendor, device, sensorId, sendValue)
