-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: Core temp (Galileo)
   Description: Read a CPU core temperature
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Sensor
   Platform: Galileo
   Unit: Degrees
   Param1: INT "Core number"
--]]

local deviceControl = require 'utils/device_control'
local SysFile = require 'drivers/sysfile'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local coreNum = params[4]

if not coreNum then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local filePath = string.format('/sys/class/thermal/thermal_zone%s/temp', coreNum)
local tempObj = SysFile.create(filePath)

local function updateSysFile()
    local value = tempObj:read()
    if value then
        return value / 1000
    end
end

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, updateSysFile, 10000)
