-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: GPO
   Description: General Purpose Output
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Actuator
   Platform: Generic
   Max: 1
   Min: 0
   Param1: STR "Gpio number"
--]]

libOpen('gpio.so.1.0')

local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'
local query = require 'db/query'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local gpioNum = params[4]

if not gpioNum then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local sensorRow = query.SELECT():
    FROM ('sensor'):
    WHERE ('vendor_ID', '=', vendorID):
    AND ('device_ID', '=', deviceID):
    AND ('sensor_ID', '=', sensorID):
    execute ().data[1]


gpioDefineOutput (sensorID, gpioNum)

deviceControl.loopDeviceThread(vendorID, deviceID, sensorID)

gpioUndefineOutput (sensorID, gpioNum)
