-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: GPS Janus
   Description: Init the modem to use the GPS and get position fixes from the GPS.
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Node
   Platform: Generic
--]]

--! \file
--! \brief Init the modem to use the GPS and get position fixes from the GPS.
--! Activate GPS for janus

libOpen("modem.so.1.0")
libOpen("gpio.so.1.0")

local deviceControl = require "utils/device_control"

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]

local function updateGPS()
    gpsGetFix("gps_time","latitude","longitude","altitude","speed")
end

gpioDefineOutput ("uart_enable", 62);
gpioDefineInput ("status", 63);
gpioDefineOutput ("on_off", 72);
gpioDefineOutput ("reset", 73);
gpioDefineOutput ("gps_reset", 74);
gpioDefineOutput ("service", 76);
gpioDefineOutput ("enable_supley", 79);
gpioDefineOutput ("enable_vbus", 67);

system(" modprobe cdc_acm")

tagSetNum("enable_vbus",0)
tagSetNum("uart_enable",1)
tagSetNum("on_off",1)
msleep(3000)
tagSetNum("on_off",0)
tagSetNum("uart_enable",0)
tagSetNum("enable_vbus",1)

msleep(3000)

getModem("/dev/ttyACM1")
gpsSetPower(1)
gpsReset(3)

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, updateGPS, 1000)

gpioUndefineOutput ("enable_vbus", 67)
gpioUndefineOutput ("enable_supley", 79)
gpioUndefineOutput ("service", 76);
gpioUndefineOutput ("gps_reset", 74);
gpioUndefineOutput ("reset", 73);
gpioUndefineOutput ("on_off", 72);
gpioUndefineInput (63);
gpioUndefineOutput ("uart_enable", 62);
