-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: GPS Janus 3G
   Description: Init the modem to use the GPS and get position fixes from the GPS. Activate GPS for janus
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Node
   Platform: Generic
--]]

--! \file
--! \brief Init the modem to use the GPS and get position fixes from the GPS.
--! Activate GPS for janus

libOpen("modem.so.1.0")
libOpen("gpio.so.1.0")

local deviceControl = require "utils/device_control"

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]

local function updateGPS()
    gpsGetFix("gps_time","latitude","longitude","altitude","speed");
end

gpioDefineOutput ("gps_reset", 74);

msleep(20000)

getModem("/dev/ttyACM4")
gpsSetPower(1)
gpsReset(3)

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, updateGPS, 1000)

gpioUndefineOutput("gps_reset", 74)
