-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: Home easy PIR 1
   Description: Remote Control PIR Motion Detector Wall Switch
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: AsyncSensor
   Platform: Generic
   Param1: INT "Id"
   Param2: INT "Index"
--]]

local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local id = tonumber(params[4])
local index = tonumber(params[5])
local frameType = 16

if not id or not index then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

-- If the RFXCOM device is not yet connected then sleep for a second
while not rfxcomBus or rfxcomBus < 0 do
    msleep (1000)
end

local handle = rfxcomRegisterDevice(rfxcomBus, id ,frameType, index, sensorID)
if handle < 0 then
    ERRORF ('Failed to register %q', sensorID)
    return
end

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, function() end, 10000)

-- TODO function runs into an assertion if bus is closed before
-- rfxcomUnregisterDevice(handle)
