-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: IIO digital
   Description: Read digital input from especified IIO file
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: AsyncSensor
   Platform: Generic
   Min: 0
   Max: 1
   Param1: STR "IIO file" "/sys/bus/iio/devices/iio:device0/in_voltage1_raw"
--]]

libOpen('iio.so.1.0')

local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local iioFile = params[4]

if not iioFile then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

iioDefineInput(sensorID, iioFile, '')

deviceControl.loopDeviceThread(vendorID, deviceID, sensorID)

iioUndefineInput(sensorID)
