-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: Kankun plug
   Description: Drive a kankun plug switch
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Actuator
   Min: 0
   Max: 1
   Platform: Kankun
--]]


--! \file
--! \brief Script to operate Kankun plug relay

local deviceControl = require 'utils/device_control'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]

local function kankunCallback (tag, value)
    NOTIFY ('Event, get tag ' .. tag)
    value = tonumber(value) or 0
    NOTIFY ('value is ' .. value)

    local f = io.open('/sys/class/leds/tp-link:blue:relay/brightness', 'w')
    if f == nil then
        ERROR ('Cannot open file to write relay status')
        return
    end

    f:write(value..'\n')
    f:close()
    NOTIFY ('Wrote ' .. value .. ' to sys')
end

deviceControl.loopActuatorThread(vendorID, deviceID, sensorID, kankunCallback)
