-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: Key barrel
   Description:
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: AsyncSensor
   Platform: Generic
   Param1: STR "Device"
   Param2: INT "Depth"
--]]

--! \file
--! \brief Script to implement barrel shifting keyboard reader

local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local device = params[4]
local depth = tonumber(params[5])
local barrelValue = ''

if not device or not depth then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local function keyInput (tag, value)
    NOTIFYF("%s has received value %s", tag, value)
    barrelValue = barrelValue .. value
    if string.len(barrelValue) > depth then 
        barrelValue = barrelValue:sub(2, depth+1)
    end
    tagSetString (sensorID, barrelValue);
    NOTIFYF("%s sensor value set to %s", sensorID, barrelValue)
end

libOpen('kbd.so.1.0', serial)

local event = "_input."..sensorID

eventHandler (event, keyInput)
kbdDefineInput (device, event)

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, function () end, 60000)

eventHandlerClear (event)

