-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: Light wave rf socket
   Description:
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Actuator
   Platform: Generic
   Param1: INT "Socket number"
--]]

local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'
local LRFSocket = require 'drivers/rfxcom/lightwaverf_socket'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local remoteID = params[4]
local socketNumber = params[5]
local socketObj

if not remoteID or not socketNumber then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local function updateLightwaveRFSocket(tag, value)
    local numVal = tonumber(value) or 0
    if numVal == 0 then
        socketObj:off()
    else
        socketObj:on()
    end
end

-- If the RFXCOM device is not yet connected then sleep for a second
while not rfxcomBus or rfxcomBus < 0 do
    msleep (1000)
end

socketObj = LRFSocket.create(rfxcomBus, remoteID, socketNumber)
if not socketObj then
    ERRORF ('Failed to init sensor %s', sensorID)
    return
end

deviceControl.loopActuatorThread(vendorID, deviceID, sensorID, updateLightwaveRFSocket)

socketObj:destroy()
