-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: LM Sensor
   Description: Provides temperatures, voltage, and fans information.
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Sensor
   Platform: Generic
   Param1: INT "Index"
   Param2: STR "Sensor"
--]]

local deviceControl = require 'utils/device_control'
local SysFile = require 'drivers/sysfile'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local index = params[4]
local sensor = params[5]

if not index or not sensor then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local filePath = string.format('/sys/class/hwmon/hwmon%s/%s', index, sensor)
local tempObj = SysFile.create(filePath)

local function updateLMSensor()
    return tempObj:read()
end

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, updateLMSensor,
1000)
