-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: Memory free
   Description: Periodically calculate free system memory
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Sensor
   Platform: Generic
   Unit: Percent
--]]

--! @file.
--! @brief Script to periodically calculate free system memory

local utils = require 'utils/utils'
local deviceControl = require 'utils/device_control'

local params = { ... }

local vendor = params[1]
local device = params[2]
local sensorId = params[3]

local function updateMemfree ()

    local free = 0
    local total = nil

    for line in io.lines('/proc/meminfo') do
        local mem = line:match('^Cached.+') or line:match('^Buffers.+') or
            line:match('^MemFree.+')
        if mem then
            free = free + tonumber(utils.split(mem, '%s')[2])
        end

        if not total then
            total = line:match('^MemTotal.+')
            total = tonumber(utils.split(total, '%s')[2])
        end
    end

    return free * 100 / total
end

deviceControl.loopSensorThread(vendor, device, sensorId, updateMemfree, 1000)
