-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: PWM (Edison)
   Description: PWM for Edison
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Actuator
   Platform: Edison
   Param1: STR "PWM number"
--]]

local PWM = require 'drivers/edison/pwm'
local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local pwmNum = params[4]
local pwmObj

if not pwmNum then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local function updatePWM(tag, value)
    value = tonumber(value) or 0
    pwmObj:setDuty(value)
end

pwmObj = PWM.create(pwmNum)
if not pwmObj then
    ERRORF ('Failed to mux pwm with %q', pwmNum)
    return
end

pwmObj:setFrequency(25000)
pwmObj:setDuty(tagGetNum(sensorID))
pwmObj:enable()

deviceControl.loopActuatorThread(vendorID, deviceID, sensorID, updatePWM)
