-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: Rayleigh smart meter (ModBus TCP)
   Description: Manage Rayleigh smart meter (ModBus TCP)
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Sensor
   Platform: Generic
   Param1: STR "IP Address"
   Param2: INT "TCP Port"
   Param3: INT "ModBus device id"
--]]

local deviceControl = require 'utils/device_control'
local rayleigh = require 'drivers/rayleigh_smart_meter'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local ipaddress = params[4]
local port = params[5]
local modbusdevid = params[6]

local ri = rayleigh.new(sensorID)
if not ri then
    return
end

if not ri:openTcp(ipaddress, port, modbusdevid) then
    return
end

ri:defineRegisters()

deviceControl.loopDeviceThread(vendorID, deviceID, sensorID)

ri:closeTcp()
