-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: SSP cash acceptance
   Description: Enable/Disable Sunset Pass cash acceptance
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Actuator
   Platform: Vending
--]]

libOpen("ssp.so.1.0")
sspOpen();

local utils = require 'utils/utils'
local deviceControl = require 'utils/device_control'

local params = { ... }

local vendor = params[1]
local device = params[2]
local sensorId = params[3]

local function setCashAcceptance (tag, value)
    NOTIFY ('Event, get tag ' .. tag)
    value = tonumber(value) or 0
    NOTIFY ('value is ' .. value)

    if (value > 0) then
        NOTIFY ('Starting cash acceptance')
        if sspSetCashAcceptance(value) then
            NOTIFY ('Cash acceptance started')
        end
    elseif (value < 0) then
        NOTIFY ('Stopping cash acceptance')
        if sspSetCashAcceptance(value) then
            NOTIFY ('Cash acceptance stoped')
        end
    end

end

deviceControl.loopActuatorThread(vendor, device, sensorId, setCashAcceptance)
