-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: VCNL4010
   Description: Proximity/Light sensor
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Sensor
   Platform: Generic
   Max: 2500
   Min: 300
   Param1:  STR "Bus"     "6"
   Param2:  INT "Address" "19"
--]]

local deviceControl = require 'utils/device_control'
local Vnl4000 = require 'drivers/vnl4000'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local bus = params[4]
local addr = params[5]
local vnlObj

if not bus or not addr then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local function updateVNL4000()
    return vnlObj:readAmbient()
end

vnlObj = Vnl4000.create(bus, addr)
if vnlObj == nil then
    ERROR('Failed to init vnl4000')
    return
end

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, updateVNL4000, 1000)
