-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: WiFi signal
   Description: WiFi signal sensor
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Sensor
   Platform: Generic
   Max: 100
   Min: -100
   Param1: STR "WiFi interface"
--]]

local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local wifiIface = params[4]

if not wifiIface then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

local function updateWifiSignal()
    local f = io.popen(string.format('iwconfig  %s', wifiIface));
    if not f then
        WARN ('Failed to open iwconfig for wifi-signal')
        return
    end
    local output = f:read('*all');
    f:close();

    local signalStr = output:match('Signal level=(-?%d+)') or ''
    local signal = tonumber(signalStr)

    if not signal then
        WARNF ('Failed to read wifi signal, got %q', signalStr)
        return
    end

    return signal
end

updateWifiSignal()
deviceControl.loopSensorThread(vendorID, deviceID, sensorID, updateWifiSignal, 10000)
