-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--[[ METADATA
   DeviceName: XBee GPO
   Description: XBee General Purpose Output
   Version: 1.0.0
   Author: Emutex LTD
   AuthorURI: http://emutex.com
   Type: Actuator
   Platform: Generic
   Max: 1
   Min: 0
   Param1:  STR "Node name"
   Param2:  INT "GPIO index"
--]]

local deviceControl = require 'utils/device_control'
local utils = require 'utils/utils'

local params = { ... }
local vendorID = params[1]
local deviceID = params[2]
local sensorID = params[3]
local nodeName = params[4]
local gpioIndex = tonumber(params[5])

if not nodeName or not gpioIndex then
    ERRORF ('%s invalid hwaddr for %q', utils.getScriptName (), sensorID)
    return
end

if gpioIndex < 0 or gpioIndex > 7 then
    ERRORF ('Invalid digital input number %q for gpio_xbee %q',
                gpioIndex, sensorID)
    return
end

local function registerSensor ()
    local msg = paramEncode ({
        node = nodeName,
        tag = sensorID,
        index = gpioIndex,
        digital = 1,
    }, 'csv')
    tagSetString ('_xbeeregister', msg)
end

deviceControl.loopSensorThread(vendorID, deviceID, sensorID, registerSensor,
                               10000)
