-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

libOpen('libserial.so.1.0')
libOpen('fieldbus.so.1.0')
libOpen('modbus.so.1.0')

local modbusMgr = {}
local busses = {}
local hndToSerport = {}

function modbusMgr.open(serport, baudrate)
    assert(type(serport) == 'string')

    if not busses[serport] then
        local handle = modbusRtuOpen(serport, baudrate)
        busses[serport] = {
            handle = handle,
            refcount = 0
        }

        hndToSerport[handle] = serport
    end

    busses[serport].refcount = busses[serport].refcount + 1
    return busses[serport].handle
end


function modbusMgr.close(handle)
    if not hndToSerport[handle] then
        return
    end

    local serport = hndToSerport[handle]
    busses[serport].refcount = busses[serport].refcount - 1

    if busses[serport].refcount == 0 then
        modbusClose(handle)
        busses[serport] = nil
        hndToSerport[handle] = nil
    end
end

return modbusMgr
