-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

--!
--! @file.
--! @brief Script gives function for change WiFi options.



local wifi = {}


--!
--! @brief Function to remplace a parameter in the file
function remplace( file , param, newParam)

    local  hFile = io.open(file, "r")
    local lines = {}
    local restOffile
    for line in hFile:lines() do
        if string.find(line, param) ~= nil then 
            lines[#lines + 1] = newParam
            restOfFile = hFile:read("*a")
            break
         else

             lines[#lines +1] = line
         end
     end
     hFile:close()

     hFile = io.open(file, "w")
     for i, line in ipairs(lines) do
         hFile:write(line, "\n")
     end
     hFile:write(restOfFile)
     hFile:close()

end

--! 
--! @brief function to reboot the WiFi system 
function rebootWifiServer()
      local handel = io.popen("ps | grep hostapd | cut -d\" \" -f 2 | head -n1")
      pid= handel:read("*a")
      print("Call to kill\n")
      print("kill -3  "..pid)
      os.execute("kill -3  "..pid)
      msleep(3000)
      os.execute("hostapd /etc/hostapd.conf &")
end

-- 
--! @brief fucntion to change SSID in the clients.
function wifi.ssidClient (newSSID)

      --Remplace in the network interface 
      remplace("/etc/network/interfaces", "wireless_essid","        wireless_essid "..newSSID)
      --It should be modified in /etc/wpa_supplicant.conf
      remplace("/etc/wpa_supplicant.conf", "ssid=","         ssid=\""..newSSID.."\"")
      
end

--
--! @brief function to  change the SSID in the server WiFi.
function wifi.ssidServer (newSSID)

      -- Remplace the SSID for the server program 
      remplace("/etc/hostapd.conf", "ssid=", "ssid="..newSSID)
      --kill process 
      rebootWifiServer()
end

-- 
--! @brief fucntion to change password in the clients.
function wifi.passwordClient (newPassword)

      --It should be modified in /etc/wpa_supplicant.conf
      remplace("/etc/wpa_supplicant.conf", "psk=","         psk=\""..newPassword.."\"")
      
end

--
--! @brief function to  change the password in the server WiFi.
function wifi.ssidServer (newPassword)

      -- Remplace the SSID for the server program 
      remplace("/etc/hostapd.conf", "wpa_passphrase=", "wpa_passphrase="..newPassword)
      --kill process 
      rebootWifiServer()
end

--! @brief function to  change the channel in the server WiFi.
function wifi.channelServer (newChannel)

      -- Remplace the SSID for the server program 
      remplace("/etc/hostapd.conf", "channel=", "channel="..newChannel)
      --kill process 
      rebootWifiServer()
end


return wifi
