-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

-- An example on how to use the adam4055

libOpen ("modbus.so.1.0")

local MODBUS_DATA_FMT_BADC  =   1 -- device_address 32 bit value, BE shorts
local MODBUS_DATA_FMT_BIT   =   7 -- device_address single bit value (may not be necessary)
local MODBUS_DATA_FMT_BYTE  =   3 -- device_address bit value, BE shorts
local modbus_fd = -1
local device_address = 1

local function step (event)
    timerStart ("modbus.timer", 200)
    print ("Step..")
    modbusUpdate ()
end

local function turnOn(event, param)
    -- param contains current value
    print("Event " .. param)
    tagSetNum("modbus.DO-0", param)
end

local function setup ()

    print ("Register Device...")
    modbusRegisterDevice ("ADAM4055", device_address, 10)

    print ("Add DI range...")
    modbusDefineDataRange (device_address, 0x00, 0x07, MODBUS_DATA_FMT_BIT, 0, 10)
    modbusDefineDataRange (device_address, 0x10, 0x17, MODBUS_DATA_FMT_BIT, 1, 10)

    print ("Add DO range...")

    print ("Add single DI ..")
    modbusDefineDataPoint (device_address, 0x12, "modbus.DO-0")
    modbusDefineDataPoint (device_address, 0x01, "modbus.DI-1")

end

print ("Start")
modbus_fd = modbusRtuOpen ("502")
setup ()

print("Put 1 modbus.DO-0")
tagSetNum("modbus.DO-0", 0)
eventHandler("modbus.DI-1", turnOn)
timerStart ("modbus.timer", 200)
eventHandler ("modbus.timer", step)

while true do
    local event, param = eventWait ()
    eventDispatch (event, param)
end
