-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

libOpen ("mqtt.so.1.0")

local mqttBroker="broker.ubiworx.com"
local mqttPort=1883
local mqttKeepalive = 5
local myTopic = "foo"
local keepRunning = true

local function eventCallback(event, param)
    -- param contains the message posted in the topic
    NOTIFYF("Received %s on topic %s", param, myTopic)
    keepRunning = false
end

local mqttClient = mqttNew(true)
if mqttStart(mqttClient, mqttBroker, mqttPort, mqttKeepalive) ~= 0 then
    ERROR("Failed to connect")
    return
end

mqttSubscribe (mqttClient, myTopic)
-- create listen for the tag to change
eventHandler(myTopic, eventCallback)
-- publish a dummy message
mqttPublish(mqttClient, myTopic, "bar")

while keepRunning do
    local event, param = eventWait()
    eventDispatch (event, param)
end
