-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

-- An example on how to use xbee

local inputDevAddr  = "0013A20040A24372"
local outputDevAddr = "0013A20040A24364"
local radioInBase   = "0013A20040A24348"
local state = 1

--! \brief Event to change some pir
local function pirChange (tag, pir)
    print ("**** PIR updated to " .. pir .. "*****")

    if (pir > 0) then
        xbeeSendData (outputDevAddr, "e")
    else
        xbeeSendData (outputDevAddr, "o")
    end
end

--! \brief Event to change temperature
local function tempChange (tag, rawVal)
    local volt = (rawVal * 1200) / 1024
    local temp = (volt - 500) / 10
    print ("**** temp change to " .. rawVal .. " volt=" .. volt .. " temp=" .. temp)
end

--! \brief define all possible event
local function main (void)
    xbeeInit ()
    timerStart ("xbee.timer", 1000)

    -- define a new xbee device by 64-bit address, with tag xbee.remote1
    xbeeDefineIoDevice (inputDevAddr, "xbee.remote1")
    -- define a new xbee device by 64-bit address, with tag xbee.remote2
    xbeeDefineDataDevice (outputDevAddr, "xbee.remote2")
    -- define digital pin 3 on this device as an input with tag xbee.remote1.pir
    xbeeDefineDigitalInput (inputDevAddr, 3, 0, "xbee.remote1.pir")
    -- define digital pin 3 on this device as an input with tag xbee.remote1.pir
    xbeeDefineAnalogInput (inputDevAddr, 2, 0, "xbee.remote1.temp")

    -- assign a timer handler
    eventHandler ("xbee.timer", step)
    eventHandler ("xbee.remote1.pir", pirChange)

    while true do
        local event, param = eventWait ()
        eventDispatch (event, param)
    end
end

main ()
