-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

local tags = require "utils/tags"

local alarm = {}

alarm.internalParser = 'csv'
alarm.systemCategory = 'SYSTEM'
alarm.limitCategory  = 'LIMIT'

function alarm.buildAlarmId(table)
    return tags.buildUbiworxTag(table)
end

function alarm.verifyMsg (alarmTable, extraFields)
    local fields = {
        'alarm_ID',
        'vendor_ID',
        'device_ID',
        'category',
        'seconds',
        'latitude',
        'longitude',
        'notes',
        'active'
    }

    for k,v in pairs(extraFields) do fields[k] = v end

    for _, field in ipairs (fields) do
        if not alarmTable[field] then
            return false, string.format ('field %q is missing', field)
        end
    end
    return true
end



return alarm
