-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

local self = {}

self.invalidVersion = '1'
self.deviceNotAllowed = '2'
self.sensorNotAllowed = '3'
self.invalidVendor = '4'
self.invalidSensorId = '5'
self.sensorRemoved = '6'
self.deviceRemoved = '7'
self.nodeNotAllowed = '8'
self.invalidNodeId = '9'
self.nodeRemoved = '10'

self.errorMessages = {
    [self.invalidVersion] =
        'Server reported invalid version. Please update your gateway',

    [self.deviceNotAllowed] =
        "The device is not allowed by the server because the vendor's " ..
        "device quota has been reached",

    [self.sensorNotAllowed] =
        'Sensor was not allowed by the server',

    [self.invalidVendor] =
        'Server reported invalid vendor. Is the vendor ID correct?',

    [self.invalidSensorId] =
        'Server reported invalid sensor ID.',

    [self.sensorRemoved] =
        'Sensor has been removed.',

    [self.deviceRemoved] =
        'Gateway has been removed.',

    [self.nodeNotAllowed] =
        'Node was not allowed by the server',

    [self.invalidNodeId] =
        'Server reported invalid node ID.',

    [self.nodeRemoved] =
        'Node has been removed.',
}

function self.toString(errorCode)
    return self.errorMessages[errorCode] or 'Unknown error code'
end

return self
