-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

local query = require "db/query"
local sysconfig = {}

function sysconfig.init ()
    local resultTable = query.
        SELECT():
        FROM("device"):
        execute()

    if resultTable.count ~= 1 then
        FATALF ("Invalid database setup, could not determine this gateway, found %d records", resultTable.count)
    end

    sysconfig._vendorID = resultTable.data[1].vendor_ID
    sysconfig._deviceID = resultTable.data[1].device_ID

    NOTIFYF ("Loaded sysconfig, vendor_ID=%s, device_ID=%s", sysconfig._vendorID, sysconfig._deviceID)
end

function sysconfig.getVendorID ()
    return sysconfig._vendorID
end

function sysconfig.getDeviceID ()
    return sysconfig._deviceID
end

return sysconfig
