-- CONFIDENTIAL AND PROPRIETARY INFORMATION

-- Copyright (c) 2013,2016 Emutex Ltd. All rights reserved.
-- This software and documentation contain confidential and
-- proprietary information that is the property of
-- Emutex Ltd. The software and documentation are
-- furnished under a license agreement and may be used
-- or copied only in accordance with the terms of the license
-- agreement. No part of the software and documentation
-- may be reproduced, transmitted, or translated, in any
-- form or by any means, electronic, mechanical, manual,
-- optical, or otherwise, without prior written permission
-- of Emutex Ltd., or as expressly provided by the license agreement.
-- Reverse engineering is prohibited, and reproduction,
-- disclosure or use without specific written authorization
-- of Emutex Ltd. is strictly forbidden.

local config = require 'utils/config'

local self = {}

function self.dayOfTheYear(localTime)
    local format = '%j'
    return tonumber(os.date(format, localTime))
end

function self.dayHasChanged(yesterday, today)
    assert(type(yesterday) == 'number' and type(today) == 'number',
        'Number type expected')
    assert(1 <= yesterday and yesterday <= 365, 'yesterday is not valid')
    assert(1 <= today and today <= 365, 'today is not valid')

    if yesterday == 365 and today == 1 then
        return true
    end
    return yesterday < today
end

function self.sampleTimestamp(vendor, device, sec, usec)
    local sampleTs = {
        sec = sec,
        usec = usec
    }

    if not config.useAbsoluteTimestamps(vendor, device) then
        local now = gettimeofday()
        sampleTs = timersub(now, sampleTs)
    end

    return sampleTs
end

return self
