#!/bin/sh

# Copyright 2015-2016 Emutex Ltd. All rights reserved.

ME=$(basename "$0")

print_usage()
{
    echo "usage: $ME <vendor_ID> <device_ID> [<root-IP>]"
}

if [ "$1" = "-h" ] || [ "$1" = "-?" ] || [ $# -lt 2 ] || [ $# -gt 3 ]; then
    print_usage
    exit 1
fi

DBASE=/usr/share/ubiworx/dbase/vxf.db
VXSERVICE=/etc/init.d/ubiworx

VENDORID=$1
DEVICEID=$2
ROOTIP=$3

if [ "$ROOTIP" = "" ]; then
    ROOTIP="broker.ubiworx.com"
fi

echo "Stopping ubiworx ..."
$VXSERVICE stop
sleep 1

echo "Setting up database with vendor_ID=$VENDORID and device_ID=$DEVICEID ..."
sqlite3 $DBASE "DELETE FROM samples"
sqlite3 $DBASE "DELETE FROM sensor"
sqlite3 $DBASE "DELETE FROM device_config"
sqlite3 $DBASE "DELETE FROM device"

sqlite3 $DBASE "INSERT INTO device VALUES ($VENDORID,'$DEVICEID','','',1,60,0,0,0,0,0)"
sqlite3 $DBASE "INSERT INTO device_config VALUES ($VENDORID,'$DEVICEID','mqttClientBroker','$ROOTIP')"
